#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <stdbool.h>

// расширения C89, C99
//---------------------------------------------------------
void testb1( void ) {         // логический тип
   bool bar[ 100 ];
   int size = sizeof( bar ) / sizeof( bar[ 0 ] ), i, s = 0;
   printf( "логические переменные\n" );
   printf( "размер _Bool = %d\n", sizeof( bar ) / size );
   for( i = 0; i < size; i++ )
      bar[ i ] = i & 1 ? false : true;
   for( i = 0; i < size; i++ )
      s += bar[ i ] ? 1 : 0;
   printf( "среди %d логических элементов значение 'true' имеют %d\n",
           size, s );
}
//---------------------------------------------------------
   void concat_str( char *s1, char *s2 ) {
      char str[ strlen( s1 ) + strlen( s2 ) + 2 ];
      strcpy( str, s1 );
      strcat( str, "." );
      strcat( str, s2 );
      printf( "%s", str );
      // return fopen( str, mode );
   }

   void testv1( void ) {         // простейший VLA
      char fn[] = "<имя_фйла>", fe[] = "<расширение>";
      printf( "массив переменой длины\n" );
      printf( "%s + %s = ", fn, fe );
      concat_str( fn, fe );
      printf( "\n" );
   }
//---------------------------------------------------------
   void concata_str( char *s1, char *s2 ) {
      char *str = (char*)alloca( strlen( s1 ) + strlen( s2 ) + 2 );
      strcpy( str, s1 );
      strcat( str, "." );
      strcat( str, s2 );
      printf( "%s", str );
   }

   void testa1( void ) {         // простейший VLA
      char fn[] = "<имя_фйла>", fe[] = "<расширение>";
      printf( "размещение alloca()\n" );
      printf( "%s + %s = ", fn, fe );
      concat_str( fn, fe );
      printf( "\n" );
   }
//---------------------------------------------------------
#include "tvla2.c"       // VLA: транспонирование матрицы               
//---------------------------------------------------------

void ( *tests[] )( void ) = {          // последовательность тестов
        testb1, testv1,
        testa1, testv2,
};
#include "../main.c"
