#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//---------------------------------------------------------
static void inc( int *arr, int size ) {
   while( size >= 0 ) arr[ size-- ]++;
}

void test070( void ) {
   printf( "параметры по ссылке и значению\n" );
   int array[] = { 1, 2, 3, 4, 5 },
       size = sizeof( array ) / sizeof( *array ), i;
   printf( "[%d]: { ", size );
   for( i = 0; i < size; i++ )
      printf( "%d%s", array[ i ], ( i != size - 1 ? " " : " }" ) );
   inc( array, size );
   printf( " => [%d]: { ", size );
   for( i = 0; i < size; i++ )
      printf( "%d%s", array[ i ], ( i != size - 1 ? " " : " }\n" ) );
}
//---------------------------------------------------------
#define SIZE 5
typedef struct vararr {
   int data[ SIZE ];
} vararr_t;

static vararr_t incv( vararr_t arr ) {
   int *p = (int*)&arr, size = SIZE;
   while( size >= 0 ) p[ size-- ]++;
   return arr;
}

void test072( void ) {
   int i;
   vararr_t array = {{ 1, 2, 3, 4, 5 }}, 
            reslt = incv( array );
   printf( "структуры: параметры и возврат по значению\n" );
   printf( "{ " );
   for( i = 0; i < SIZE; i++ )
      printf( "%d%s", array.data[ i ], ( i != SIZE - 1 ? " " : " }" ) );
   printf( " => { " );
   for( i = 0; i < SIZE; i++ )
      printf( "%d%s", reslt.data[ i ], ( i != SIZE - 1 ? " " : " }\n" ) ); 
}
//---------------------------------------------------------

void ( *tests[] )( void ) = {          // последовательность тестов
        test070,                       // ссылка - значение
        test072,
};
#include "../main.c"




