#include <stdio.h>
#include <stdlib.h>

// bit operations
#define LEN 32
char *c10to2( unsigned int n ) {
   static char str[ LEN + 1 ], *p;
   *( p = str + sizeof( str ) - 1 ) = '\0';
   do *--p = ( n & 1 ? '1' : '0' );
   while( ( n >>= 1 ) > 0 );
   return p;
}

#define FMT "%32s"
int main() {
   while( 1 ) {
      printf( "введите два десятичных числа: ");
      unsigned int d1, d2, i;
      if( scanf( "%u%u", &d1, &d2 ) != 2 ) break;
      printf( "   " FMT "\n", c10to2( d1  ) );
      printf( "   " FMT "\n", c10to2( d2  ) );
      printf( "   " );
      for( i = 0; i <= LEN; i++ ) printf( "%c", '-' );
      printf( "\n" );  // разделитель
      printf( "&: " FMT "\n", c10to2( d1 & d2 ) ); 
      printf( "|: " FMT "\n", c10to2( d1 | d2 ) ); 
      printf( "^: " FMT "\n", c10to2( d1 ^ d2 ) ); 
      printf( "   " ); // разделитель
      for( i = 0; i <= LEN; i++ ) printf( "%c", '-' );
      printf( "\n" );
      printf( "~: " FMT "\n", c10to2( ~d1 ) ); 
      printf( "~: " FMT "\n", c10to2( ~d2 ) ); 
   }
   printf( "\n" ); // выход по ^D (EOF)
   return 0;
}
